include \masm32\include\masm32rt.inc ;\asm\win32.inc
.586

jeaxz macro l:req
 test eax,eax
 jz l
endm

.data?
hinst    DWORD ?
hstatic     dd ?
timelo      dd ?
timehi      dd ?
buffer      db 22 dup (?)
buffend     db ?,?

.const
frmtitle BYTE 'Whatever',0
frmclass BYTE 'wclassw',0
static      db 'static',0

.code

pnum64:     push esi
            push edi
		mov esi,10
            mov edi,offset buffend
  next1: 	mov ecx,eax
		mov eax,edx
		sub edx,edx
		div esi
		xchg ecx,eax
		div esi
            add edx,'0'
            mov [edi],dl
		mov edx,ecx
            dec edi
		test eax,eax
		jnz next1
            lea eax,[edi+1]
            pop edi
            pop esi
            ret            


frmproc proc public uses ebx hwnd:DWORD,msg:DWORD,wparam:DWORD,lparam:DWORD
    mov eax,msg
    mov edx,wparam

    cmp eax,WM_CREATE
    jnz @f
    invoke CreateWindowEx,0,offset static,0,WS_CHILD+WS_VISIBLE,8,8,100,16,hwnd,1,hinst,0
    mov hstatic,eax
    invoke SetTimer,hwnd,1,1000,0
    rdtsc
    mov timelo,eax
    mov timehi,edx
    sub eax,eax
    jmp done

  @@:
    cmp eax,WM_CLOSE
    jnz @f
    INVOKE PostQuitMessage,0
    sub eax,eax
    jmp done

  @@:
    cmp eax,WM_DESTROY
    jnz @f
    INVOKE KillTimer,hwnd,1
    jmp def

  @@:
    cmp eax,WM_TIMER
    jnz @f
    rdtsc
    push eax
    push edx
    sub eax,timelo
    sbb edx,timehi
    pop timehi
    pop timelo
    call pnum64
    invoke SendMessage,hstatic,WM_SETTEXT,0,eax
    sub eax,eax
    jmp done
  @@:
  def:
    INVOKE DefWindowProc,hwnd,msg,wparam,lparam
  done:
    ret

frmproc endp

;my standard starting point template from here -------------------
;include \asm\win32\start.inc

start proc public
    local m:MSG
    sub ebx,ebx

    push ebx
    call GetModuleHandle
    mov hinst,eax

    push ebx                ;hIconSm
    push OFFSET frmclass    ;lpszClassName
    push ebx                ;lpszMenuName
    push 1                  ;hbrBackground
    push 32512
    push ebx
    call LoadCursor
    push eax                ;hCursor
    push 32512
    push ebx
    call LoadIcon
    push eax                ;hIcon
    push hinst              ;hInstance
    push ebx                ;cbWndExtra
    push ebx                ;cbClsExtra
    push OFFSET frmproc     ;lpfnWndProc
    push 3                  ;style
    push 48                 ;cbSize
    push esp
    call RegisterClassEx
    add esp,48
    jeaxz done

    push ebx                ;lpParam
    push hinst              ;hInstance
    push ebx                ;hMenu
    push ebx                ;hwndParent
    push 100                ;nHeight
    push 200                ;nWidth
    push ebx                ;Y
    push ebx                ;X
    push (WS_VISIBLE or WS_BORDER or WS_CAPTION or \
          WS_MINIMIZEBOX or WS_CLIPCHILDREN or WS_SYSMENU)
    push OFFSET frmtitle    ;lpWindowName
    push OFFSET frmclass    ;lpClassName
    push ebx                ;dwExStyle
    call CreateWindowEx
    jeaxz done

    lea esi,m
  next:
    INVOKE GetMessage,esi,ebx,ebx,ebx
    jeaxz done
    INVOKE TranslateMessage,esi
    INVOKE DispatchMessage,esi
    jmp next
  done:
    push eax
    jmp ExitProcess
start ENDP
end start
